let rec tri_fusion = function
    | [] -> []
    | [ a ] -> [ a ]
    | l ->  let (l1,l2) = dcoupe l
            in
            fusion (tri_fusion l1) (tri_fusion l2)
and dcoupe = function
    | [] -> [],[]
    | [ a ] -> [ a ],[]
    | a :: b :: q
        ->  let (l1,l2) = dcoupe q
            in
            (a :: l1) , (b :: l2)
and fusion l1 l2 = match l1,l2 with
    | [],_ -> l2
    | _,[] -> l1
    | ((x,y,c) as a)::q1, ((x',y',c') as b)::q2
        ->  if c < c' then a :: (fusion q1 l2)
            else b :: (fusion l1 q2) ;;         

let kruskal nb_sommets artes =
    let la = tri_fusion artes
    in
    let partition = cre_partition nb_sommets
    in
    let rec itre partition la = match partition with
        | (1,_,_) -> []
        | (n,_,_)
            ->  let (x,y,c) = hd la
                in
                let ((n',_,_) as partition) = union partition x y
                in
                if n = n' then itre partition (tl la)
                else (x,y,c) :: (itre partition (tl la))
    in
    itre partition la ;;
